---
- name: Check for Step CLI
  stat:
    path: "/usr/bin/step"
  register: stat_result

- name: Exit if nothing to upgrade
  fail: msg="Step CLI not installed ..."
  when: not stat_result.stat.exists

- name: Get Server Provisioner from Vault
  set_fact:
    secret: "{{ lookup('community.hashi_vault.hashi_vault', 'stepca/data/provisioner:server') }}"

- block:
    - name: Write Secret to Temp
      copy:
        content: "{{ secret }}"
        dest: /tmp/secret

    - file:
        path: /etc/docker
        state: directory

    - file:
        path: /etc/docker/ssl
        state: directory

    - name: Install Step Certificates
      shell: |
        sudo step ca certificate \
          {{ inventory_hostname }} \
          --provisioner server \
          --provisioner-password-file /tmp/secret \
          /etc/docker/ssl/{{ inventory_hostname }}.crt \
          /etc/docker/ssl/{{ inventory_hostname }}.key \
          -f 
  always:
    - name: Remove Secret
      file:
        path: /tmp/secret
        state: absent
      ignore_errors: yes


- include_tasks: debian.yml
  when: ansible_os_family == 'Debian'

- include_tasks: redhat.yml
  when: ansible_os_family == 'RedHat'

- name: Create docker daemon directory
  file:
    path: "/etc/systemd/system/docker.service.d/"
    state: directory

- name: Create override.conf
  template:
    src: override.conf.j2
    dest: "/etc/systemd/system/docker.service.d/override.conf"

- name: Create docker daemon json
  template:
    src: docker.json.j2
    dest: /etc/docker/daemon.json
  tags:
    - config

- name: Rester Docker Daemon
  block:
    - service_facts:

    - ansible.builtin.systemd:
        daemon_reload: yes

    - ansible.builtin.systemd:
        name: docker
        state: started
        enabled: yes

